package support;

import java.text.SimpleDateFormat;
import java.util.Date;

import model.Clazz;
import model.dao.ClazzDao;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.beans.propertyeditors.StringTrimmerEditor;
import org.springframework.web.bind.WebDataBinder;
import org.springframework.web.bind.support.WebBindingInitializer;
import org.springframework.web.context.request.WebRequest;

public class BindingInitializer implements WebBindingInitializer {

	public void initBinder(WebDataBinder binder, WebRequest request) {
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		dateFormat.setLenient(false);

		binder.registerCustomEditor(String.class,
				new StringTrimmerEditor(false));
		binder.registerCustomEditor(Date.class, new CustomDateEditor(
				dateFormat, false));
		binder
				.registerCustomEditor(Clazz.class, new ClazzEditor(
						this.clazzDao));

	}

	@Autowired
	private ClazzDao clazzDao;

}
